unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button3: TButton;
    StaticText1: TStaticText;
    UpDown1: TUpDown;
    Label1: TLabel;
    Button1: TButton;
    StaticText2: TStaticText;
    procedure FormPaint(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const x1 = 340;  //start line AB
      x2 = 460;
      y1 = 590;
      y2 = 590;

procedure inittree;
var r : Trect;
begin
 with form1 do
  begin
   statictext2.Caption := 'drawing busy....';
   with paintbox1 do with Canvas do
    begin
     r := rect(0,0,width,height);
     brush.Color := $ffffff;
     brush.Style := bsSolid;
     fillrect(r);
     pen.color := $000000;
     pen.Width := 1;
     moveto(x1,y1);
     lineto(x2,y2);
    end;
  end;
end;

procedure makeTree(ax,ay,bx,by : smallInt; depth : byte);
//paint part of tree
var cx,cy,dx,dy,ex,ey : smallInt;
    x,y,zx,zy : smallInt;
begin
 x := bx-ax;
 y := ay-by;
 cx := ax-y;
 cy := ay-x;
 dx := bx-y;
 dy := by-x;
 zx := (cx + dx) div 2;
 zy := (cy + dy) div 2;
 ex := zx - (y div 2);
 ey := zy - (x div 2);
 with form1.PaintBox1.Canvas do
  begin
   pen.color := $000000;
   pen.width := 1;
   moveto(ax,ay);
   lineto(cx,cy);
   lineto(dx,dy);
   lineto(bx,by);
   moveto(cx,cy);
   lineto(ex,ey);
   lineto(dx,dy);
   if depth > 1 then
    begin
     maketree(cx,cy,ex,ey,depth-1);
     maketree(ex,ey,dx,dy,depth-1);
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
//pythagoras tree
begin
 inittree;
 maketree(x1,y1,x2,y2,updown1.position);
 statictext2.Caption := 'finished';
end;

procedure TForm1.Button1Click(Sender: TObject);
//all trees
var depth : byte;
    clk : dword;
begin
 inittree;
 depth := 0;
 repeat
  inc(depth);
  updown1.Position := depth;
  clk := gettickcount + 500;
  while gettickcount < clk do application.ProcessMessages;
  maketree(x1,y1,x2,y2,depth);
 until depth = 15;
 statictext2.Caption := 'finished';
end;

procedure TForm1.FormPaint(Sender: TObject);
//edge around paintbox1
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with paintbox1 do
  begin
   x1 := left-2;
   y1 := top-2;
   x2 := left+ width+1;
   y2 := top + height + 1;
  end;
 with canvas do
  begin
   pen.width := 1;
   for i := 0 to 1 do
    begin
     pen.color := $000000;
     moveto(x2-i,y1 + i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := $000080;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

end.
